//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// SharedFilesCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SharedFilesCtrl.h"
#include "otherfunctions.h"


// CSharedFilesCtrl

IMPLEMENT_DYNAMIC(CSharedFilesCtrl, CMuleListCtrl)
CSharedFilesCtrl::CSharedFilesCtrl(){
}

CSharedFilesCtrl::~CSharedFilesCtrl(){
}

void CSharedFilesCtrl::Init(){
	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(LVS_SINGLESEL,0);
	InsertColumn(0, GetResString(IDS_DL_FILENAME) ,LVCFMT_LEFT,250,0);
	InsertColumn(1,GetResString(IDS_DL_SIZE),LVCFMT_LEFT,100,1);
	InsertColumn(2,GetResString(IDS_TYPE),LVCFMT_LEFT,50,2);
	InsertColumn(3,GetResString(IDS_PRIORITY),LVCFMT_LEFT,70,3);
	InsertColumn(4,GetResString(IDS_PERMISSION),LVCFMT_LEFT,100,4);
	InsertColumn(5,GetResString(IDS_FILEID),LVCFMT_LEFT,220,5);
	InsertColumn(6,GetResString(IDS_SF_REQUESTS),LVCFMT_LEFT,100,5);
	InsertColumn(7,GetResString(IDS_SF_ACCEPTS),LVCFMT_LEFT,100,5);
	InsertColumn(8,GetResString(IDS_SF_TRANSFERRED),LVCFMT_LEFT,120,5);

	m_SharedFilesMenu.CreatePopupMenu();
	m_SharedFilesMenu.AddMenuTitle(GetResString(IDS_SHAREDFILES));
	
	// add priority switcher
	m_PrioMenu.CreateMenu();
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOVERYLOW,GetResString(IDS_PRIOVERYLOW));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
	m_PrioMenu.AppendMenu(MF_STRING,MP_PRIOVERYHIGH, GetResString(IDS_PRIOHIGHEST));

	// add permission switcher
	m_PermMenu.CreateMenu();
	m_PermMenu.AppendMenu(MF_STRING,MP_PERMNONE,	GetResString(IDS_FSTATUS_LOCKED));
	m_PermMenu.AppendMenu(MF_STRING,MP_PERMFRIENDS,	GetResString(IDS_FSTATUS_FRIENDSONLY));
	m_PermMenu.AppendMenu(MF_STRING,MP_PERMALL,		GetResString(IDS_FSTATUS_PUBLIC));


	// todo enable when it works
	m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PrioMenu.m_hMenu, GetResString(IDS_PRIORITY) );
	//m_SharedFilesMenu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_PermMenu.m_hMenu, (LPCTSTR)"Permissions");
	m_SharedFilesMenu.AppendMenu(MF_STRING|MF_SEPARATOR);
	m_SharedFilesMenu.AppendMenu(MF_STRING,MP_OPEN, GetResString(IDS_OPENFILE));
	m_SharedFilesMenu.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1));
	m_SharedFilesMenu.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2));

	LoadSettings(CPreferences::tableShared);
}

void CSharedFilesCtrl::Localize() {
	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	HDITEM hdi;
	hdi.mask = HDI_TEXT;
	CString strRes;

	strRes = GetResString(IDS_DL_FILENAME);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(0, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_DL_SIZE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(1, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_TYPE);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(2, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_PRIORITY);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(3, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_PERMISSION);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(4, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_FILEID);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(5, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_SF_REQUESTS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(6, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_SF_ACCEPTS);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(7, &hdi);
	strRes.ReleaseBuffer();

	strRes = GetResString(IDS_SF_TRANSFERRED);
	hdi.pszText = strRes.GetBuffer();
	pHeaderCtrl->SetItem(8, &hdi);
	strRes.ReleaseBuffer();
}

void CSharedFilesCtrl::ShowFileList(CSharedFileList* in_sflist){
	DeleteAllItems();
	sflist = in_sflist;
	CCKey bufKey;
	CKnownFile* cur_file;
	for (POSITION pos = sflist->m_Files_map.GetStartPosition();pos != 0;){
		sflist->m_Files_map.GetNextAssoc(pos,bufKey,cur_file);
		ShowFile(cur_file);
	}	
}

void CSharedFilesCtrl::UpdateFile(CKnownFile* file,uint32 itemnr){
	char buffer[50];
	char buffer2[50];
	char buffer3[50];

	CastItoXBytes(file->GetFileSize(),buffer);
	SetItemText(itemnr,1,buffer);
	if (file->GetPriority() == PR_VERYLOW)
		SetItemText(itemnr,3,GetResString(IDS_PRIOVERYLOW ));
	else if (file->GetPriority() == PR_LOW)
		SetItemText(itemnr,3,GetResString(IDS_PRIOLOW ));
	else if (file->GetPriority() == PR_NORMAL)
		SetItemText(itemnr,3,GetResString(IDS_PRIONORMAL ));
	else if (file->GetPriority() == PR_HIGH)
		SetItemText(itemnr,3,GetResString(IDS_PRIOHIGH ));
	else if (file->GetPriority() == PR_VERYHIGH)
		SetItemText(itemnr,3,GetResString(IDS_PRIOHIGHEST ));

	/*if (file->GetPermissions() == PERM_NOONE)
		SetItemText(itemnr,4,"Hidden");
	else if (file->GetPermissions() == PERM_FRIENDS)
		SetItemText(itemnr,4,"Friends Only");
	else
		SetItemText(itemnr,4,"Public Shared");*/
	SetItemText(itemnr,4,GetResString(IDS_FSTATUS_PUBLIC));

	buffer[0] = 0;
	for (uint16 i = 0;i != 16;i++) // hmm I wonder if there is a standard function for this
		sprintf(buffer,"%s%02X",buffer,file->GetFileHash()[i]);
	SetItemText(itemnr,5,buffer);

	sprintf(buffer,"%u (%u)",file->statistic.GetRequests(),file->statistic.GetAllTimeRequests());SetItemText(itemnr,6,buffer);
	sprintf(buffer,"%u (%u)",file->statistic.GetAccepts(),file->statistic.GetAllTimeAccepts());SetItemText(itemnr,7,buffer);
	
	CastItoXBytes(file->statistic.GetTransfered(),buffer);
	CastItoXBytes(file->statistic.GetAllTimeTransfered(),buffer2);
	sprintf(buffer3,"%s (%s)",buffer,buffer2 );SetItemText(itemnr,8,buffer3);

}

void CSharedFilesCtrl::ShowFile(CKnownFile* file){
	ShowFile(file,GetItemCount());
}

void CSharedFilesCtrl::ShowFile(CKnownFile* file,uint32 itemnr){
	InsertItem(LVIF_TEXT|LVIF_PARAM,itemnr,file->GetFileName(),0,0,0,(LPARAM)file);
	UpdateFile(file,itemnr);
}

BEGIN_MESSAGE_MAP(CSharedFilesCtrl, CMuleListCtrl)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
END_MESSAGE_MAP()



// CSharedFilesCtrl message handlers
void CSharedFilesCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
	m_SharedFilesMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON,point.x,point.y,this);
}



BOOL CSharedFilesCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int iSel = GetSelectionMark();
	if (iSel != (-1)){
		CKnownFile* file = (CKnownFile*)GetItemData(iSel);
		switch (wParam){
			case MP_GETED2KLINK:
				{
					theApp.CopyTextToClipboard(theApp.CreateED2kLink(file));
					break;
				}
			case MP_GETHTMLED2KLINK:
				{
					theApp.CopyTextToClipboard(theApp.CreateHTMLED2kLink(file));
					break;
				}
			case MP_OPEN:
				{
					char* buffer = new char[250];
					sprintf(buffer,"%s\\%s",file->GetPath(),file->GetFileName());
					theApp.emuledlg->AddLogLine( false, "%s\\%s",file->GetPath(),file->GetFileName());
					ShellOpenFile(buffer);
					delete buffer;
					break; 

				}
			case MP_PRIOVERYLOW:
			case MP_PRIOLOW:
			case MP_PRIONORMAL:
			case MP_PRIOHIGH:
			case MP_PRIOVERYHIGH:
				{
					POSITION pos = this->GetFirstSelectedItemPosition();
					while( pos != NULL )
					{ 
						int iSel=this->GetNextSelectedItem(pos);
						file = (CKnownFile*)this->GetItemData(iSel);
						switch (wParam) {
							case MP_PRIOVERYLOW:
								{	file->SetPriority(PR_VERYLOW);SetItemText(iSel,3,GetResString(IDS_PRIOVERYLOW ));break;	}
							case MP_PRIOLOW:
								{	file->SetPriority(PR_LOW);SetItemText(iSel,3,GetResString(IDS_PRIOLOW ));break;	}
							case MP_PRIONORMAL:
								{	file->SetPriority(PR_NORMAL);SetItemText(iSel,3,GetResString(IDS_PRIONORMAL ));break;	}
							case MP_PRIOHIGH:
								{	file->SetPriority(PR_HIGH);SetItemText(iSel,3,GetResString(IDS_PRIOHIGH ));break;	}
							case MP_PRIOVERYHIGH:
								{	file->SetPriority(PR_VERYHIGH);SetItemText(iSel,3,GetResString(IDS_PRIOHIGHEST ));break;	}
						}
					}
					break;
				}
			case MP_PERMNONE:
				{
					if (((CPartFile*)file)->IsPartFile())
						AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
					else
					{	
						file->SetPermissions(PERM_NOONE);
						SetItemText(iSel,4,GetResString(IDS_HIDDEN));
					}
					break;
				}
			case MP_PERMFRIENDS:
				{
					if (((CPartFile*)file)->IsPartFile())
						AfxMessageBox(GetResString(IDS_ERR_NOPRIMCHANGE));
					else
					{	
						file->SetPermissions(PERM_FRIENDS);
						SetItemText(iSel,4,GetResString(IDS_FSTATUS_FRIENDSONLY ));	
					}
					break;
				}
			case MP_PERMALL:
				{	file->SetPermissions(PERM_ALL);SetItemText(iSel,4,GetResString(IDS_FSTATUS_PUBLIC));break;	}
		}
	}
	return true;
}


void CSharedFilesCtrl::OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult){
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	int adder=0;
	if (pNMListView->iSubItem>5 && pNMListView->iSubItem<9) {
		if (!asc_sort[pNMListView->iSubItem]) sortstat[pNMListView->iSubItem-6]=!sortstat[pNMListView->iSubItem-6];
		adder=sortstat[pNMListView->iSubItem-6] ? 0:100;
	}

	// if it's a second click on the same column then reverse the sort order,
	// otherwise sort the new column in ascending order.
	asc_sort[pNMListView->iSubItem] = !asc_sort[pNMListView->iSubItem];
	if (adder==0)	SetSortArrow(pNMListView->iSubItem, asc_sort[pNMListView->iSubItem]); else
		SetSortArrow(pNMListView->iSubItem,asc_sort[pNMListView->iSubItem]	 ? arrowDoubleUp:arrowDoubleDown);
	SortItems(&SortProc,pNMListView->iSubItem+ adder+((asc_sort[pNMListView->iSubItem])? 0:10));
	*pResult = 0;
}

int CSharedFilesCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort){
	CKnownFile* item1 = (CKnownFile*)lParam1;
	CKnownFile* item2 = (CKnownFile*)lParam2;	
	switch(lParamSort){
		case 0: //filename asc
			return strcmpi(item1->GetFileName(),item2->GetFileName());
		case 10: //filename desc
			return strcmpi(item2->GetFileName(),item1->GetFileName());

		case 1: //filesize asc
			return item1->GetFileSize()-item2->GetFileSize();
		case 11: //filesize desc
			return item2->GetFileSize()-item1->GetFileSize();
/*
		case 2: //filetype asc
			return strcmpi( GetFiletypeByName( (CString)item1->GetFileName()),GetFiletypeByName( (CString)item2->GetFileType() ));
		case 12: //filetype desc
			return strcmpi(GetFiletypeByName((CString)item2->GetFileName()),GetFiletypeByName((CString)item1->GetFileType()));
*/
		case 3: //prio asc
			if(item1->GetPriority() == PR_VERYLOW )
				return 1;
			else if (item2->GetPriority() == PR_VERYLOW)
				return 0;
			else
				return item2->GetPriority()-item1->GetPriority();
		case 13: //prio desc
			if(item1->GetPriority() == PR_VERYLOW )
				return 0;
			else if (item2->GetPriority() == PR_VERYLOW)
				return 1;
			else
				return item1->GetPriority()-item2->GetPriority();

		case 4: //permission asc
			return item2->GetPermissions()-item1->GetPermissions();
		case 14: //permission desc
			return item1->GetPermissions()-item2->GetPermissions();

		case 5: //fileID asc
			return strcmpi((CString)item1->GetFileHash(),(CString)item2->GetFileHash());
		case 15: //fileID desc
			return strcmpi((CString)item2->GetFileHash(),(CString)item1->GetFileHash());

		case 6: //requests asc
			return item1->statistic.GetRequests() - item2->statistic.GetRequests();
		case 16: //requests desc
			return item2->statistic.GetRequests() - item1->statistic.GetRequests();
		case 7: //acc requests asc
			return item1->statistic.GetAccepts() - item2->statistic.GetAccepts();
		case 17: //acc requests desc
			return item2->statistic.GetAccepts() - item1->statistic.GetAccepts();
		case 8: //all transferred asc
			return item1->statistic.GetTransfered() - item2->statistic.GetTransfered();
		case 18: //all transferred desc
			return item2->statistic.GetTransfered() - item1->statistic.GetTransfered();
		case 106: //all requests asc
			return item1->statistic.GetAllTimeRequests() - item2->statistic.GetAllTimeRequests();
		case 116: //all requests desc
			return item2->statistic.GetAllTimeRequests() - item1->statistic.GetAllTimeRequests();
		case 107: //all acc requests asc
			return item1->statistic.GetAllTimeAccepts() - item2->statistic.GetAllTimeAccepts();
		case 117: //all acc requests desc
			return item2->statistic.GetAllTimeAccepts() - item1->statistic.GetAllTimeAccepts();
		case 108: //all transferred asc
			return item1->statistic.GetAllTimeTransfered() - item2->statistic.GetAllTimeTransfered();
		case 118: //all transferred desc
			return item2->statistic.GetAllTimeTransfered() - item1->statistic.GetAllTimeTransfered();


		default: 
			return 0;
	}
}

void CSharedFilesCtrl::UpdateItem(CKnownFile* toupdate){
	LVFINDINFO find;
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)toupdate;
	sint16 result = FindItem(&find);
	if (result != -1) {
		UpdateFile(toupdate,result);
		theApp.emuledlg->sharedfileswnd.Check4StatUpdate(toupdate);
	}
}